package com.brainysoftware.jdk5.app13;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class ObjectSerializationTest {

    public static void main(String[] args) {
        // Serialize
        try {
            Customer customer = new Customer(1, "Joe Blog", "12 West Cost");
            FileOutputStream fos = new FileOutputStream(
                    "c:\\temp\\objectOutput");
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            // write first object
            oos.writeObject(customer);
            // write second object
            oos.writeObject("Customer Info");
            oos.close();
            fos.close();
        } catch (FileNotFoundException e) {
            System.out.print("FileNotFound");
        } catch (IOException e) {
            System.out.print("IOException");
        }

        // Deserialize
        try {
            FileInputStream fis = new FileInputStream("c:\\temp\\objectOutput");
            ObjectInputStream ois = new ObjectInputStream(fis);
            // read first object
            Customer customer2 = (Customer) ois.readObject();
            System.out.println("First Object: ");
            System.out.println(customer2.id);
            System.out.println(customer2.name);
            System.out.println(customer2.address);

            // read second object
            System.out.println();
            System.out.println("Second object: ");
            String info = (String) ois.readObject();
            System.out.println(info);
            ois.close();
            fis.close();
        } catch (ClassNotFoundException ex) {
            System.out.print("ClassNotFound " + ex.getMessage());

        } catch (IOException ex2) {
            System.out.print("IOException " + ex2.getMessage());
        }
    }
}
